/////////////////////////////////////////////////////////////////////////////////
//
// BkMailPart.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMailPart.cpp,v $
 * Revision 1.4  2000/08/06 15:14:41  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 * Revision 1.3  2000/07/20 05:10:48  syou
 * - PGP/MIME[̏،ʕ\@Aꂽp[gƓKw
 *   multipartƂĂ݂Bmulipart`ŕ̔폐p[g[
 *   ɂāȀЂƂЂƂ̌،ʂ\邱ƂlAUTF-8
 *   ISO-8859-1Ƃ[p[g؂ĂȂ1ނ̃GR[fB
 *   OXL[Ō،ʂ\ł悤ɂ邽߁BA[{̂
 *   Subjectŉ炩̃GR[hsĂƁAep[gContent-Typew
 *   QƂȂȂ錻ۂB2ibeta22jŌ󂯂Bǂ̂낤B
 *   Iɂ́Aɏ揼BkCommon.hABkCommon.cppɎĂ܂
 *   B揼񂪗t@C̃o[WAbvvĂȒPɒǏ]ł
 *   ͂Ȃ̂ǂACMIMEItemɗ~֐
 *   ł̂ƁAƂGetNameAndAddr()CMIMEItem::~CMIMEItem()̃
 *   [NACMIMEItemɑ΂ACMIMEItem::SetHeader()găwb_ݒ肵
 *   ĂƂɃANZXᔽN邱Ƃւ̑ΏȂǂs߁B
 *   񂩂A_CrtSetDbgFlag()giC}KW8Ƃ̂͂܂
 *   RƂĂj[NΏɂƂ߂B݂̂ƂAĂ
 *   Ń胊[N͑Ώς݁B
 *   APGPsdkUILibInit()ɂPGP UICȕDllMain()JɏW
 *   ȂǁB
 *
 * Revision 1.2  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.1  2000/07/05 23:50:32  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.1  2000/06/29 15:53:11  syou
 * - class CBkMessageAclass CBkMailPartAclass CBkMail
 *   FindMIMEItemFirst()A FindMIMEItemNext()A ExploreItemTree()A
 *   IsMIMEItem()AȂǂȂǎBׂẮAPGPDecodevO
 *   邽߁BJavaCNnewIuWFNg߂悤
 *   ̂ŁAdeleteȂ΂ȂȂԂA
 *   Ȃ߃Ã΃ǃЃуŃʃł́Atemplate class count_ptr
 *   BA͏O̖{Ƃ肾̂Ȃ̂ŁAŐV
 *   ł͂ȂmȂBŔނWeby[WQƂKv邩
 *   ȁBDecoden̎͂ꂩȂ̂ŁA PGPsdk̃TvvO
 *   Ă (^^;  ܂܂ꂩ炾cc
 *
 *
 */


#include "BkMessage.h"


/////////////////////////////////////////////////////////////////////////////////
//
CBkMailPart::CBkMailPart(const CBkMailPart& bmp)
{
    m_pbmParent = bmp.m_pbmParent;
}


CBkMailPart::CBkMailPart(CBkMessage* pbmParent, CMIMEItem* pItem)
{
    m_pbmParent = pbmParent;
    m_pItem = pItem;
}


CBkMailPart& CBkMailPart::operator =(const CBkMailPart& bmp)
{
    CBkMessage::operator =(bmp);
    if (this != &bmp) {
        m_pbmParent = bmp.m_pbmParent;
    }
    return *this;
}


CBkMailPart* CBkMailPart::SetChild(CMIMEItem* pChild)
{
    m_pItem->SetChild(pChild);
    NotifyChanged();
    if (pChild == NULL) {
        return NULL;
    }
    return new CBkMailPart(m_pbmParent, pChild);
}


CBkMailPart* CBkMailPart::AddChild(CMIMEItem* pChild)
{
    if (pChild == NULL) {
        return NULL;
    }
    m_pItem->AddChild(pChild);
    NotifyChanged();
    if (pChild == NULL) {
        return NULL;
    }
    return new CBkMailPart(m_pbmParent, pChild);
}


CBkMailPart* CBkMailPart::SetNext(CMIMEItem* pNext)
{
    m_pItem->SetNext(pNext);
    NotifyChanged();
    if (pNext == NULL) {
        return NULL;
    }
    return new CBkMailPart(m_pbmParent, pNext);
}


CBkMailPart* CBkMailPart::FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag)
{
    m_listItem.clear();
    ExploreItemTree(lpszType, lpszSubType, m_pItem, dwFlag);
    if (m_listItem.empty()) {
        return NULL;
    }

    m_iMimeItem = m_listItem.begin();
    if (m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(m_pbmParent, *m_iMimeItem);
}


CBkMailPart* CBkMailPart::FindMIMEItemNext()
{
    if (++m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(m_pbmParent, *m_iMimeItem);
}


CBkRfc822* CBkMailPart::GetRfc822()
{
    LPSTR lpSource = m_pItem->ToString();
    LPCTSTR lpContent = strstr(lpSource, "\r\n\r\n");
    if (lpContent == NULL) {
        free(lpSource);
        return NULL;
    }
    lpContent += 4;

    if (*lpContent == NULL) {
        free(lpSource);
        return NULL;
    }

    LPSTR lpTemp = const_cast<LPSTR>(lpContent);
    CMIMEItem* pItem = new CMIMEItem();
    pItem->FromString(lpTemp);
    free(lpSource);

    return new CBkRfc822(pItem);
}


LPSTR CBkMailPart::GetPGPOriginalText(BOOL bPGPMIME)
{
    LPSTR lpTxt = NULL;
    if (bPGPMIME) {

        LPSTR lpSource = m_pItem->ToString();
        LPCTSTR lpContent = strstr(lpSource, "\r\n\r\n");
        if (lpContent == NULL) {
            free(lpSource);
            return NULL;
        }
        lpContent += 4;

        if (*lpContent == NULL) {
            free(lpSource);
            return NULL;
        }

        lpTxt = (LPSTR) malloc(strlen(lpContent) + 3072);//m_pbka->Alloc(strlen(lpContent) + 3072);
        if (lpTxt == NULL) {
            free(lpSource);
            return NULL;
        }

        char szType[1024];
        char szEncoding[1024];
        GetHeader("Content-Type", szType, 1024);
        GetHeader("Content-Transfer-Encoding", szEncoding, 1024);
        sprintf(lpTxt, "Content-Type: %sContent-Transfer-Encoding: %s\r\n%s", szType, szEncoding, lpContent);
        free(lpSource);
    }
    return lpTxt;
}


