/////////////////////////////////////////////////////////////////////////////////
//
// SignatureListener.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: SignatureListener.h,v $
 * Revision 1.2  2000/07/15 02:09:56  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */

#pragma once


#include "EventListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
class CSignatureListener : public CEventListener
{
public:
    CSignatureListener();
    virtual ~CSignatureListener();
    virtual PGPError ListenEvent(PGPContextRef context, PGPEvent* event);
    virtual const PGPEventSignatureData GetData() const;
    virtual const char* GetName() const;
    virtual const PGPValidity GetKeyValidity() const;
    virtual BOOL IsChecked() const;
    virtual BOOL IsVerified() const;
    virtual BOOL IsSigned() const;

protected:
    virtual void SetSignatureEventData(PGPEvent* event);

private:
    char* name;
    HWND hWnd;
    BOOL bSigned;
    PGPEventSignatureData sigData;
};


/////////////////////////////////////////////////////////////////////////////////
//
